com.smartgwt.client.types

## Enum TreeModelType

- java.lang.Object
- - java.lang.Enum<TreeModelType>
  - - com.smartgwt.client.types.TreeModelType

- All Implemented Interfaces:
    ValueEnum, java.io.Serializable, java.lang.Comparable<TreeModelType>

      public enum TreeModelType
      extends java.lang.Enum<TreeModelType>
      implements ValueEnum

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `CHILDREN` In this model, nodes specify their children as a list of nodes.
    `PARENT` In this model, each node has an ID unique across the whole tree and a parent ID that points to its parent.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getValue()`
    `static TreeModelType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static TreeModelType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### PARENT

          public static final TreeModelType PARENT

      In this model, each node has an ID unique across the whole tree and a parent ID that points to its parent. The name of the unique ID property can be specified via `idField` and the name of the parent ID property can be specified via `parentIdField`. The initial set of nodes can be passed in as a list to `data` and also added as a list later via `Tree.linkNodes`. Whether or not a given node is a folder is determined by the value of the property specified by `isFolderProperty`.
      The "parent" modelType is best for integrating with relational storage (because nodes can map easily to rows in a table) and collections of Beans and is the model used for DataBound trees.

    - #### CHILDREN

          public static final TreeModelType CHILDREN

      In this model, nodes specify their children as a list of nodes. The property that holds the children nodes is determined by `childrenProperty`. Nodes are not required to have an ID that is unique across the whole tree (in fact, no ID is required at all). Node names (specified by the `nameProperty`, unique within their siblings, are optional but not required. Whether or not a given node is a folder is determined by the presence of the children list (`childrenProperty`).

  - ### Method Detail

    - #### values

          public static TreeModelType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (TreeModelType c : TreeModelType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static TreeModelType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getValue

          public java.lang.String getValue()

      Specified by:
        `getValue` in interface `ValueEnum`